//
// BeInternetCentral
// Application class
//
// (c) 1997 Hubert Figuiere
// figuiere@kagi.com
//
// 26june1997


/*
#include "HAboutBox.h"
*/
#include "app/BICApplication.h"
#include "app/BICWindow.h"

#include "sdk/libbic.h"

BICRegistry * gBicRegistry = NULL;
bool gBicPresent = false;


///////////////////////////////////////////////////////////////////
BICApplication::BICApplication()
	: BApplication("application/x-vnd.hub-beinternetcentral")
{
	mWindow = NULL;
	bic_version versionInUse = BIC_CURRENT_VERSION;
	status_t err = create_bic_registry(gBicRegistry, versionInUse);
	if (err == B_NO_ERROR) {
		gBicPresent = true;
		mWindow = new BICWindow(BPoint(100, 100));
	}
	else {
		printf("create_bic_registry = %lx\n", err);
	}
}


///////////////////////////////////////////////////////////////////
BICApplication::~BICApplication()
{
	if (gBicPresent) {
		status_t err = dispose_bic_registry(gBicRegistry);	
	}
	gBicPresent = false;
}



///////////////////////////////////////////////////////////////////
void BICApplication::ReadyToRun()
{
	mWindow->Show();
	if (!gBicPresent) {
		mWindow->PostMessage(B_QUIT_REQUESTED);
	}
}


///////////////////////////////////////////////////////////////////
void BICApplication::AboutRequested()
{
/*
	HAboutBox * aboutBox = new HAboutBox("BeInternetCentral 1.0",
			"© Hubert Figuière", "About BeInternetCentral"B_UTF8_ELLIPSIS, false);
	
	aboutBox->Show();
*/
}



///////////////////////////////////////////////////////////////////
