//
// BeInternetCentral
// Personality class
//
// (c) 1997 Hubert Figuiere
// figuiere@kagi.com
//
// 27june1997



#include "app/BICApplication.h"
#include "app/BICWindow.h"
#include "app/BICCommands.h"
#include "app/PersonalityView.h"



/////////////////////////////////////////////////////
PersonalityView::PersonalityView(BRect frame)
	: TopicView(frame, "Personality")
{
}



/////////////////////////////////////////////////////
void PersonalityView::AttachedToWindow(void)
{
	inherited::AttachedToWindow();
	BRect viewBounds = Bounds();
	BRect aRect;
	BMenuField * aMenuField;

	mPersonalityMenu = new BPopUpMenu("", true, true, B_ITEMS_IN_COLUMN);
	
	aRect.Set(10, 20, viewBounds.right - 10, 36);
	aMenuField = new BMenuField(aRect, "", "Personality :", mPersonalityMenu);
	mBox->AddChild(aMenuField);
	aMenuField->SetDivider(100.);	
	
	aRect.top = aRect.bottom + 10;
	aRect.bottom = aRect.top + 16;
	mNameTextControl = new BTextControl(aRect, "", "Name :", "", 
			BICWindow::MakeCommandMessage(NAME_CHANGED));
	mBox->AddChild(mNameTextControl);		
	mNameTextControl->SetTarget(Window());
	mNameTextControl->SetDivider(100.);
	
	aRect.top = aRect.bottom + 10;
	aRect.bottom = aRect.top + 16;
	mEmailAddressTextControl = new BTextControl(aRect, "", "E-mail :", "", 
			BICWindow::MakeCommandMessage(EMAIL_CHANGED));
	mBox->AddChild(mEmailAddressTextControl);		
	mEmailAddressTextControl->SetTarget(Window());
	mEmailAddressTextControl->SetDivider(100.);
	
	aRect.top = aRect.bottom + 10;
	aRect.bottom = aRect.top + 16;
	mOrganizationTextControl = new BTextControl(aRect, "", "Organization :", "", 
			BICWindow::MakeCommandMessage(ORGANIZATION_CHANGED));
	mBox->AddChild(mOrganizationTextControl);		
	mOrganizationTextControl->SetTarget(Window());
	mOrganizationTextControl->SetDivider(100.);

	TopicView::ReloadPersonalityList(mPersonalityMenu, mCurrentPersonality);
}



/////////////////////////////////////////////////////
void PersonalityView::CurrentPersonalityChanged(BMessage * /*msg*/)
{
	ReloadPersonalityConfig();	
}





/////////////////////////////////////////////////////
void PersonalityView::ReloadPersonalityConfig()
{
	status_t err;
	ssize_t size = 256;
	ssize_t realSize;
	key_value value = (key_value)malloc((size + 1) * sizeof(char));
	if (value == NULL) {
		debugger("out of memory");
		return;
	}

	/*real name*/
	realSize = size;
	err = gBicRegistry->GetKey(KEY_REAL_NAME, mCurrentPersonality, value, realSize);
	if (err == BIC_BUFFER_TOO_SMALL) {
		value = (key_value)realloc(value, (realSize + 1) * sizeof(char));
		size = realSize;
		err = gBicRegistry->GetKey(KEY_REAL_NAME, mCurrentPersonality, value, realSize);
	}	
	if (err == B_NO_ERROR) {
		//set up the value...
		mNameTextControl->SetText(value);
	}

	/*email address*/
	realSize = size;
	err = gBicRegistry->GetKey(KEY_EMAIL_ADRESS, mCurrentPersonality, value, realSize);
	if (err == BIC_BUFFER_TOO_SMALL) {
		value = (key_value)realloc(value, (realSize + 1) * sizeof(char));
		size = realSize;
		err = gBicRegistry->GetKey(KEY_EMAIL_ADRESS, mCurrentPersonality, value, realSize);
	}	
	if (err == B_NO_ERROR) {
		//set up the value...
		mEmailAddressTextControl->SetText(value);
	}

	/*organization*/
	realSize = size;
	err = gBicRegistry->GetKey(KEY_ORGANIZATION, mCurrentPersonality, value, realSize);
	if (err == BIC_BUFFER_TOO_SMALL) {
		value = (key_value)realloc(value, (realSize + 1) * sizeof(char));
		size = realSize;
		err = gBicRegistry->GetKey(KEY_ORGANIZATION, mCurrentPersonality, value, realSize);
	}	
	if (err == B_NO_ERROR) {
		//set up the value...
		mOrganizationTextControl->SetText(value);
	}

}


/////////////////////////////////////////////////////
